<?php

namespace App\Services\Part;

use RuntimeException;
use App\Models\Part\SWITCHModel;
use App\Helpers\Part\SWITCHHelper;
use App\Forms\Part\SWITCHForm;
use App\Entities\Part\SWITCHEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\Entities\Equipment\ServerEntity;

class SWITCHService extends PartType3Service
{
    protected string $formClass = SWITCHForm::class;
    protected string $helperClass = SWITCHHelper::class;

    public function __construct(SWITCHModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('SWITCH');
    }
    public function getEntityClass(): string
    {
        return SWITCHEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): SWITCHEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy('code ASC');
        parent::setOrderBy($field, $value);
    }

    //서버관련 작업
    //파트정보가져오기
    public function getPartEntityByServer(ServerEntity $serverEntity): SWITCHEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverEntity->getSwitchInfoUid());
        if (!$entity instanceof SWITCHEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverEntity->getSwitchInfoUid()}에 해당하는 스위치정보를 찾을수없습니다.");
        }
        return $entity;
    }
    public function attachToServer(ServerEntity $serverEntity, array $formDatas = []): SWITCHEntity
    {
        /** @var SWITCHEntity $entity IDE에 entity type알려주기*/
        $entity = parent::attachToServer($serverEntity, $formDatas);
        return $entity;
    }
    public function detachFromServer(ServerEntity $serverEntity, array $formDatas = []): SWITCHEntity
    {
        /** @var SWITCHEntity $entity IDE에 entity type알려주기*/
        $entity = parent::detachFromServer($serverEntity, $formDatas);
        return $entity;
    }
    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): SWITCHEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof SWITCHEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 Switch정보를 찾을수없습니다.");
        }
        return $entity;
    }
}
